//+------------------------------------------------------------------+
//|                                         HG Volume (AAD Edit).mq4 |
//|                   Copyright 2009, ScottStone, HiddenGap, AAD... |
//|                                     http://www.ForexFactory.com/ |
//+------------------------------------------------------------------+

#property copyright "Copyright 2009, ScottStone, HiddenGap, Edit By AAD..."
#property link "www.ForexFactory.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Magenta
#property indicator_color4 Gold
#property indicator_color5 MidnightBlue
#property indicator_color6 Maroon
#property indicator_color7 Purple
#property indicator_color8 LightCyan

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2

extern ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
extern string Note1="Red = Volume bar is less than or equal to the previous volume bar...";
extern string Note2="Blue = Volume bar is greater than the previous volume bar...";
extern string Note3="Magenta = Volume bar is less than the two previous volume bars. This is key for No Demands and Tests type bars...";
extern string Note4="Gold = Lowest volume bar in the last 20 bars...";
extern string Note5="Midnight Blue = Climatic action (Range*V) highest high value in the last 20 bars and volume increasing from previous bar...";
extern string Note6="Maroon = Climatic action and volume less than or equal to previous bar...";
extern string Note7="Purple = Climatic action and volume less than the previous two bars...";
extern string  Note = "0 Means Display All Bars";
extern int     NumberOfBars = 1000;
extern int     MAPeriod = 100;
extern int     LookBack = 20;
//extern int     fontsize = 8;
extern string ___Edit___="(( Edit By AAD ))";

double red[],blue[],magenta[],gold[],midnightblue[],maroon[],purple[],v4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      SetIndexBuffer(0,red);
      SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexLabel(0,"Vol<Or=ThanPreviousBar ");
      
      SetIndexBuffer(1,blue);
      SetIndexStyle(1,DRAW_HISTOGRAM);     
      SetIndexLabel(1,"Vol>ThanPreviousBar ");
      
      SetIndexBuffer(2,magenta);
      SetIndexStyle(2,DRAW_HISTOGRAM);      
      SetIndexLabel(2,"Vol<ThanPrevious2Bars ");
      
      SetIndexBuffer(3,gold);
      SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexLabel(3,"Vol<ThanPrevious20Bars ");
      
      SetIndexBuffer(4,midnightblue);
      SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexLabel(4,"Climax+Range>ThanPrevious20Bars ");
      
      SetIndexBuffer(5,maroon);
      SetIndexStyle(5,DRAW_HISTOGRAM);
      SetIndexLabel(5,"VolClimaxBut<Or=ThanPreviousBar ");
      
      SetIndexBuffer(6,purple);
      SetIndexStyle(6,DRAW_HISTOGRAM);
      SetIndexLabel(6,"VolClimaxBut<ThanPrevious2Bars ");
      
      SetIndexBuffer(7,v4);
      SetIndexStyle(7,DRAW_LINE,0,1);
      SetIndexLabel(7,"SMA ("+MAPeriod+") ");
      
      IndicatorShortName("HG Volume" );
      TimeFrame = MathMax(TimeFrame,_Period);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   /*
   ObjectDelete("AvgVol");
   ObjectDelete("PerOfAvg");
   ObjectDelete("PrevPerOfAvg");
   */
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  /*
  ObjectDelete("AvgVol");
  ObjectDelete("PerOfAvg");
  ObjectDelete("PrevPerOfAvg");
  */
  
   double VolLowest,Range,Value2,Value3,HiValue2,HiValue3,LoValue3,tempv2,tempv3,tempv;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if ( NumberOfBars == 0 ) 
      NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; limit = MathMin(Bars-1,MathMax(limit,2*TimeFrame/_Period)); //Bars-counted_bars;
   
      
   for(int i=0; i<limit; i++)   
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         red[i] = 0; blue[i] = iVolume(NULL,TimeFrame,y); magenta[i] = 0; gold[i] = 0; midnightblue[i] = 0; maroon[i] = 0; purple[i] = 0;
         Value2=0;Value3=0;HiValue2=0;HiValue3=0;LoValue3=99999999;tempv2=0;tempv3=0;tempv=0;
         
              
          VolLowest = iVolume(NULL,TimeFrame,iLowest(NULL,TimeFrame,MODE_VOLUME,20,y));
         //gold: Lowest volume bar in the last 20 bars.
         if (iVolume(NULL,TimeFrame,y) == VolLowest)
            {
               gold[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               blue[i]=0;
             }
         
               
         Range = (iHigh(NULL,TimeFrame,y)-iLow(NULL,TimeFrame,y));
         Value2 = iVolume(NULL,TimeFrame,y)*Range;
         
         if (  Range != 0 )
            Value3 = iVolume(NULL,TimeFrame,y)/Range;
            
         
         for ( int n=0;n<MAPeriod;n++ )
            {
               tempv= iVolume(NULL,TimeFrame,y+n) + tempv; 
            } 
          v4[i] = NormalizeDouble(tempv/MAPeriod,0);
          //double AvgVoltest = v4[1]; 
          
   /*
   ObjectCreate("AvgVol", OBJ_LABEL, 1, 0, 0);
   ObjectSetText("AvgVol","AvgVol: " +DoubleToStr((v4[0]),0), 10, "Comic Sans MS Bold" ,Crimson);
   ObjectSet("AvgVol", OBJPROP_CORNER, 1);
   ObjectSet("AvgVol", OBJPROP_XDISTANCE, 10);
   ObjectSet("AvgVol", OBJPROP_YDISTANCE, 45);
   
   double Volume1 = iVolume(NULL,0,0);
   double Percent = (Volume1/v4[0]) *100;
   
   ObjectCreate("PerOfAvg", OBJ_LABEL, 1, 0, 0);
   ObjectSetText("PerOfAvg","CurrVol: " + DoubleToStr((Percent),0)+"%", fontsize, "Comic Sans MS Bold" ,Lime);
   ObjectSet("PerOfAvg", OBJPROP_CORNER, 1);
   ObjectSet("PerOfAvg", OBJPROP_XDISTANCE, 10);
   ObjectSet("PerOfAvg", OBJPROP_YDISTANCE, 5);
   
   double Volume2 = iVolume(NULL,0,1);
   double Percent2 = (Volume2/v4[1]) *100; 
   
   ObjectCreate("PrevPerOfAvg", OBJ_LABEL, 1, 0, 0);
   ObjectSetText("PrevPerOfAvg","PrevVol: " + DoubleToStr((Percent2),0)+"%", fontsize, "Comic Sans MS Bold" ,Orange);
   ObjectSet("PrevPerOfAvg", OBJPROP_CORNER, 1);
   ObjectSet("PrevPerOfAvg", OBJPROP_XDISTANCE, 10);
   ObjectSet("PrevPerOfAvg", OBJPROP_YDISTANCE, 20);
   */
          
          for ( n=0;n<LookBack;n++)
            {
               tempv2 = iVolume(NULL,TimeFrame,y+n)*((iHigh(NULL,TimeFrame,y+n)-iLow(NULL,TimeFrame,y+n))); 
               if ( tempv2 >= HiValue2 )
                  HiValue2 = tempv2;
                    
               if ( iVolume(NULL,TimeFrame,y+n)*((iHigh(NULL,TimeFrame,y+n)-iLow(NULL,TimeFrame,y+n))) != 0 )
                  {           
                     tempv3 = iVolume(NULL,TimeFrame,y+n) / ((iHigh(NULL,TimeFrame,y+n)-iLow(NULL,TimeFrame,y+n)));
                     if ( tempv3 > HiValue3 ) 
                        HiValue3 = tempv3; 
                     if ( tempv3 < LoValue3 )
                        LoValue3 = tempv3;
                  } 
            }
            
       //Volume bars will also show the "climatic volume" colors if the volume is greater than 
       //or equal to 3 standard deviations of the average volume for the last 30 bars.  
            
            //Blue: Volume bar is greater than the previous volume bar.
          /*
          if (Volume[i] > Volume[i+1])
            {
               blue[i] = NormalizeDouble(Volume[i],0);
            }
          */
            //Red: Volume bar is less than or equal to the previous volume bar.                            
          if (iVolume(NULL,TimeFrame,y) != VolLowest && iVolume(NULL,TimeFrame,y) <= iVolume(NULL,TimeFrame,y+1) )
            {
               red[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               blue[i]=0;
               gold[i]=0;
               midnightblue[i]=0;
            }   
            //Magenta: Volume bar is less than the two previous volume bars. This is key for No demands and tests type bars.
          if (iVolume(NULL,TimeFrame,y) != VolLowest &&  iVolume(NULL,TimeFrame,y) < iVolume(NULL,TimeFrame,y+1) && iVolume(NULL,TimeFrame,y) < iVolume(NULL,TimeFrame,y+2) )
            {
               magenta[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               blue[i]=0;
               red[i]=0;
               midnightblue[i]=0;
               gold[i]=0;
            }
            //Midnight Blue: Climatic action (range*V) highest high value 20 and volume increasing from previous bar.  
          if (iVolume(NULL,TimeFrame,y) != VolLowest &&  Value2 == HiValue2  && iVolume(NULL,TimeFrame,y) > iVolume(NULL,TimeFrame,y+1) || iVolume(NULL,TimeFrame,y) >= v4[i]*3)
            {
               midnightblue[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               blue[i] =0;
               gold[i]=0;                
            }
            //Maroon: Climatic action and volume less than or equal to previous bar.   
          if (iVolume(NULL,TimeFrame,y) != VolLowest &&  Value2 == HiValue2  && iVolume(NULL,TimeFrame,y) <= iVolume(NULL,TimeFrame,y+1) )
            {  
               maroon[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               midnightblue[i]=0;
               magenta[i]=0;
               blue[i]=0;
               red[i]=0;
               purple[i]=0;
               gold[i]=0;
            }     
            //Purple: Climatic action and volume less than the previous two bars.    
          if (iVolume(NULL,TimeFrame,y) != VolLowest &&  Value2 == HiValue2  && iVolume(NULL,TimeFrame,y) < iVolume(NULL,TimeFrame,y+1) && iVolume(NULL,TimeFrame,y) < iVolume(NULL,TimeFrame,y+2) )
            {
               purple[i] = NormalizeDouble(iVolume(NULL,TimeFrame,y),0);
               maroon[i]=0;
               magenta[i]=0;
               blue[i]=0;
               red[i]=0;
               midnightblue[i]=0;
               gold[i]=0;
            }   
         
      }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
         